C  MODPATH release: Version 4.00 (V4, Release 3, 1-2002)
C    Changes to work with MODFLOW-2000
C
C MODPATH Version 3.00 (V3, Release 2, 5-99)
C Changes:
C   No change from previous release: (V3, Release 1, 9-94)
C***** SUBROUTINES *****
C     DRIVER
C***********************
 
C***** SUBROUTINE *****
      SUBROUTINE DRIVER (QX,QY,QZ,POR,IBOUND,XMAX,DELR,YMAX,DELC,ZBOT,
     2ZTOP,HEAD,BUFF,LAYCON,NCON,IBUFF,IUNIT,XLC,YLC,ZLC,
     3ZLLC,TOT,JLC,ILC,KLC,QSS,QSTO,
     4INILOC,PERLEN,NUMTS,TIMX,IBSTRT,HDRY,
cjed  ADD PARTICLE INDEX VARIABLE NPARTC,MODEL IDENTIFIER IDMODEL, X,Y,Z OFFSETS
cjed  ADD OUTPUT UNIT NOS IUOUTEP,IUOUTTS,IUOUTEP FOR GLOBAL OUTPUT FILES
cjed  ADD IBFLG,NGRIDS,NMPSTOP
cjed     5HNOFLO,VER,LAYCBD,ISSFLG) 

cjed  7-19-08 removed npartc    
cjed     5HNOFLO,VER,LAYCBD,ISSFLG,NPARTC,IUOUTEP,IUOUTTS,IUOUTPL,IDMODEL,
cjed     6XOFF,YOFF,ZOFF,ISLGR)
     5HNOFLO,VER,LAYCBD,ISSFLG,IUSTART,IUOUTEP,IUOUTEPGL,IUOUTTS,
     6IUOUTPL,IUOUTPROJ,XOFF,YOFF,ZOFF,NROWP,NCOLP,NLAYP,DELRP,DELCP,
     7TOPP,BOTMP,PXMAX,PYMAX,ISLGR,IBFLG,NGRIDS,IDMODEL,NUMITER)
Cjed  end addition

      USE MPATHADV
      
      INCLUDE 'idat1.inc'
      COMMON /IDAT2/ IRCHTP,IEVTTP,NRCHOP,NEVTOP

      DIMENSION LAYCBD(200)
      DIMENSION TOT(NPART),XLC(NPART),YLC(NPART),ZLC(NPART),
     1ZLLC(NPART),JLC(NPART),ILC(NPART),KLC(NPART),QX(NCP1,NROW,NLAY),
     2QY(NCOL,NRP1,NLAY),QZ(NCOL,NROW,NLP1),POR(NCOL,NROW,NLPOR),
     3IBOUND(NCOL,NROW,NLAY),XMAX(NCOL),DELR(NCOL),YMAX(NROW),
     4DELC(NROW),ZBOT(NZDIM),ZTOP(NZDIM),
     5IBUFF(NCOL,NROW,NLAY),IUNIT(NUNIT),HEAD(NCOL,NROW,NLAY),
     6LAYCON(NLAY),NCON(NLAY),BUFF(NCOL,NROW,NLAY),QSS(NCOL,NROW,NLAY),
     7IBSTRT(NCOL,NROW,NLAY),
cjed  ADD PARTICLE INDEX VARIABLE NPARTC     
cjed     9QSTO(NCOL,NROW,NLAY),INILOC(NPART)
cjed  removed npartc 7-19-08
cjed     9QSTO(NCOL,NROW,NLAY),INILOC(NPART),NPARTC(NPART)
     9QSTO(NCOL,NROW,NLAY),INILOC(NPART),DELRP(NCOLP),DELCP(NROWP),
     1TOPP(NROWP,NCOLP),BOTMP(NROWP,NCOLP,NLAYP+1),PXMAX(NCOLP),
     2PYMAX(NROWP)
      
cjed
      DIMENSION PERLEN(NPER),NUMTS(NPER),TIMX(NPER),ISSFLG(NPER)
      CHARACTER*78 MES
      CHARACTER*(*) VER
      CHARACTER*40 PART_ASSOC,PARTASSOC

cjed start addition
      DIMENSION NPARTC(500000),IDMODSTART(500000),PART_ASSOC(500000)

cjed onemodel
c      DIMENSION IBFLG(NGRIDS)
      INTEGER NMPSTOP,NUMITER,IUSTART
      NMPSTOP=0
cjed  end addition
C
C  GET TRIMMED LENGTH OF VERSION HEADER STRING
      CALL CHOP(VER,LVER)
C
      CALL DATIN (LAYCON,NCON,HEAD,DELT,XMAX,YMAX,DELR,DELC,
     1ZTOP,ZBOT,IBOUND,POR,QX,QY,QZ,IUNIT,IRP,NPRT,FRAC,BUFF,
     2IREV,IBUFF,JLC,ILC,KLC,XLC,YLC,ZLLC,ITMS,QSS,QSTO,ISNK,ITREAD,
     3IZSTOP,IPEP,MAXSTP,
     4INILOC,TSTOP,TIMREL,KKPER,KKSTP,PERLEN,NUMTS,
cjed  ADD PARTICLE INDEX NUMBER NPARTC     
cjed     5TIMX,IBSTRT,ZLC,HDRY,HNOFLO,TOT,ICMPCT,TBGABS,LAYCBD,ISSFLG)
     5TIMX,IBSTRT,ZLC,HDRY,HNOFLO,TOT,ICMPCT,TBGABS,LAYCBD,ISSFLG,ISLGR,
     6NPARTC,PART_ASSOC,IDMODEL,NUMITER,IUSTART)
cjed     
C
C  CHECK MASS BALANCES
C
      MES= 'DO YOU WANT TO COMPUTE VOLUMETRIC BUDGETS FOR ALL CELLS ?'
      CALL YESNO (MES,IANS,'3.1.4')
      IF(IANS.EQ.1) THEN
      CALL MPRMPT('SPECIFY AN ERROR TOLERANCE (IN PERCENT):')
      CALL GETR(1,ETOL,1,0.,0.,'3.1.1')
      IF(ISS.EQ.0) THEN
      NSTEP=0
      CALL READHQ(QX,QY,QZ,QSS,QSTO,HEAD,IBOUND,BUFF,NCOL,
     1 NROW,NLAY,NCP1,NRP1,NLP1,I10,NSTEP,DTSTP,TOTSIM,IERR,
     2 NUMTS,NPER,NSTEPF,NSTEPL,KPER,KSTP,0,I7)
      WRITE(I7,*) ' '
      WRITE(I7,9300) NSTEPF,NSTEPL
9300  FORMAT(1X,'COMPUTE BUDGETS FOR MODFLOW CUMULATIVE TIME STEPS ',I6,
     1' THROUGH ',I6)
      DO 5 NSTEP=NSTEPF,NSTEPL
      CALL READHQ(QX,QY,QZ,QSS,QSTO,HEAD,IBOUND,BUFF,NCOL,
     1 NROW,NLAY,NCP1,NRP1,NLP1,I10,NSTEP,DTSTP,TOTSIM,IERR,
     2 NUMTS,NPER,NSTEPF,NSTEPL,KPER,KSTP,1,I7)
      CALL BALNCE (QX,QY,QZ,QSS,QSTO,IBOUND,HEAD,NCOL,NROW,NLAY,
     1NCP1,NRP1,NLP1,NUMERR,I7,ISILNT,ETOL,KPER,KSTP,ISS,HDRY)
5     CONTINUE
      ELSE IF(ISS.EQ.1) THEN
      CALL BALNCE (QX,QY,QZ,QSS,QSTO,IBOUND,HEAD,NCOL,NROW,NLAY,
     1NCP1,NRP1,NLP1,NUMERR,I7,ISILNT,ETOL,1,1,ISS,HDRY)
      END IF
      END IF
C
C  CHECK DATA CELL BY CELL
C
      MES= ' DO YOU WANT TO CHECK DATA CELL BY CELL ?'
      CALL YESNO (MES,IANS,'3.1.2')
      IF(IANS.EQ.1) THEN
      CALL CELDAT (XMAX,YMAX,DELR,DELC,ZBOT,ZTOP,DELZCB,POR,IBOUND,HEAD,
     1 QX,QY,QZ,LAYCON,NCOL,NROW,NLAY,NZDIM,IGRID,NLPOR,NCP1,NRP1,NLP1,
     2 NCON,QSS,IBATCH,I7,QSTO,ISS,BUFF,NUMTS,NPER,I10,IBSTRT)
      END IF
C
      MES= 'SUMMARIZE FINAL STATUS OF PARTICLES IN SUMMARY.PTH FILE ?'
      CALL YESNO(MES,IOP,'3.1.3')
C
      IF (IBATCH.EQ.0) THEN
      WRITE (*,*) ' '
      WRITE (*,*) 'NOW COMPUTING PARTICLE PATHS...'
      WRITE (*,*) ' '
      IF(NPRT.EQ.0) THEN
        WRITE(*,*) 'NUMBER OF PARTICLES = 0. RUN STOPPED.'
        NMPSTOP=1
cjed  ADD RETURN INSTEAD OF STOP
        RETURN
cjed        STOP
cjed  END ADDITION        
      END IF
      END IF
 
      IF(NPRT.EQ.0) THEN
        WRITE(I7,*) 'NUMBER OF PARTICLES = 0. RUN STOPPED.'
cjed  ADD RETURN INSTEAD OF STOP
        NMPSTOP=1
        RETURN
cjed        STOP
cjed  END ADDITION
      END IF
C
cjed addition from MPATH5.0
      IF(MODE.EQ.2 .AND. IUNIT(18).GT.0) THEN
         ALLOCATE(VXE(NPRT),VYE(NPRT),VZE(NPRT),TOTE(NPRT))
         ALLOCATE(XLCE(NPRT),YLCE(NPRT),ZLCE(NPRT))
         DO 43 N=1,NPRT
         VXE(N)=0.
         VYE(N)=0.
         VZE(N)=0.
         tote(N)=0.
         xlce(N)=0.
         ylce(N)=0.
         zlce(N)=0.
 43      CONTINUE
      END IF
cjed

C
C... initialize for first pass through time loop
C
C... ISTOP is a flag that is used to indicate if another pass through
C       the time loop should be made.
C       ISTOP =  0 --> make another pass through time loop
C       ISTOP = -1 --> time at end of current modflow time step is
C                      greater than a user-specified stopping time
C                      (a negative value of ISTOP may be reset to 0
C                       if the current request time is less than the
C                       user-specified stop time)
C       ISTOP =  1 --> do not make another pass through the time loop
C
      ISTOP=0
 
      KOUNT=1
      TOLD=0.0E+0
      TIMREQ=0.0
 
      IF(ITREAD.EQ.1) READ(I8,*) MAXSTP,TFAC
      CALL GETREQ(ITMS,ITREAD,MAXSTP,KOUNT,DELT,TFAC,TIMREQ,I8)
      IF(ISS.EQ.0) THEN
      CALL GETSTP(KKPER,KKSTP,NUMTS,NPER,I7,NSTEP)
      CALL READHQ(QX,QY,QZ,QSS,QSTO,HEAD,IBOUND,BUFF,NCOL,
     1 NROW,NLAY,NCP1,NRP1,NLP1,I10,NSTEP,DTSTP,TOTSIM,IERR,
     2 NUMTS,NPER,NSTEPF,NSTEPL,KPER,KSTP,1,I7)
      IF(IERR.EQ.1) THEN
      WRITE(*,*) 'TIME STEP NOT FOUND IN COMPOSITE BUDGET FILE. STOP.'
      WRITE(I7,*) 'TIME STEP NOT FOUND IN COMPOSITE BUDGET FILE. STOP.'
      STOP
      ELSE
      WRITE(I7,*) ' '
      WRITE(I7,9000) KKPER,KKSTP,NSTEP
9000  FORMAT(1X,'INITIAL BUDGET AND HEAD DATA READ FROM CBF FOR:'
     1/10X,'PERIOD ',I4,2X,'STEP ',I5,2X,'(CUMULATIVE TIME STEP = ',I6,
     2')')
      END IF
      IF(IREV.EQ.1) THEN
      TIMSTP=TIMREL*DTSTP
      ELSE
      TIMSTP= (1.0-TIMREL)*DTSTP
      END IF
      ELSE IF(ISS.EQ.1) THEN
      NSTEP=1
      TIMSTP=1.0E+30
      END IF
      IF(IREV.EQ.1) CALL FLIPQ(QX,QY,QZ,NCOL,NROW,NLAY,NCP1,NRP1,NLP1)
 
      IF(TSTOP.LE.TIMSTP) THEN
      ISTOP= -1
      TIMSTP=TSTOP
      END IF
 
C  WRITE VERSION HEADER STRING ON LINE 1 OF TIMESERIES FILE
      IF(MODE.EQ.2) CALL FILHDR(I4,VER,ICMPCT,TBGABS)

C
C  COMPUTE GLOBAL Z COORDINATES OF PARTICLES THAT ARE ACTIVE AT TIME 0.
C  IF TIME SERIES MODE, WRITE INITIAL CONDITIONS IN TIMESERIES FILE
C
        DO 50 N=1,NPRT
          IF(TOT(N).EQ.-1.0) THEN
            CALL ZCALC(IGRID,NCOL,NROW,NLAY,ZLC(N),ZLLC(N),ZTOP,ZBOT,
     1               HEAD(JLC(N),ILC(N),KLC(N)),LAYCON(KLC(N)),
cjed        ADD PARTICLE INDEX VARIABLE NPARTC     
c     2               ILC(N),JLC(N),KLC(N),NZDIM,I7)
     2               ILC(N),JLC(N),KLC(N),NZDIM,I7) ! 1-12-11 removed from end ,NPARTC(N))
!     3               IDMODSTART(N),PART_ASSOC(N)
cjed     
cjed        ADD PARTICLE INDEX VARIABLE NPARTC
cjed            READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NDUMMY
cjed            WRITE(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NSTEP
cjed        ADD STARTING GLOBAL Z LOCATION
            ZSTRT=ZLC(N)
cjed        END ADDITION            
            READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NDUMMY,
     1       NPARTSTRT,IDMODEL_START,PARTASSOC
            WRITE(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NSTEP,
c     1       NPARTSTRT,IDMODEL_START,ZSTRT,PARTASSOC  ! switch position of partassoc and zstrt
     1       NPARTSTRT,IDMODEL_START,PARTASSOC,ZSTRT
            NPARTC(N)=NPARTSTRT
            IDMODSTART(N)=IDMODEL_START
            PART_ASSOC(N)=PARTASSOC
cjed
            IF (MODE.EQ.2) THEN
cjed        ADD PARTICLE INDEX NPARTC
cjed              CALL WRITTS(I4,ICMPCT,0,N,JLC(N),ILC(N),KLC(N),XLC(N),
cjed     1          YLC(N),ZLC(N),ZLLC(N),0.0,NSTEP,NROW,NCOL)
              CALL WRITTS(I4,IUOUTTS,ISLGR,IDMODSTART(N),IDMODEL,ICMPCT ! 1-11-11 change IDMODEL_START to IDMODSTART(N)
     1       ,0,N,JLC(N),ILC(N),KLC(N),XLC(N),YLC(N),ZLC(N),ZLLC(N),0.0,
     2       NSTEP,NROW,NCOL,NPARTC(N),XOFF,YOFF,ZOFF,PART_ASSOC(N))

cjed
            END IF
          END IF
50      CONTINUE
C
C  FIND THE TIME OUT CONDITION FOR THE FIRST PASS THROUGH THE TIME LOOP
C
C... ICASE = 1 --> request time > end of current modflow time step
C                  (new flows must be loaded at the end of this pass
C                   through the time loop)
C... ICASE = 2 --> request time < end of current modflow time step
C                  (existing flows can be used for this pass and the
C                   next pass through the time loop)
C... ICASE = 3 --> request time = end of current modflow time step
C                  (new flows must be loaded at the end of this pass
C                   through the time loop)
      IF(TIMREQ.GT.TIMSTP) THEN
      ICASE=1
      TMAX=TIMSTP
      ELSE IF(TIMREQ.LT.TIMSTP) THEN
      ICASE=2
      TMAX=TIMREQ
      IF(ISTOP.LT.0) ISTOP=0
      ELSE IF(TIMREQ.EQ.TIMSTP) THEN
      ICASE=3
      TMAX=TIMSTP
      END IF
 
C... WRITE VERSION HEADER STRING TO PATHLINE FILE
      IF(MODE.EQ.1) CALL FILHDR(I2,VER,ICMPCT,TBGABS)
C
C---------------------  START TIME LOOP  -------------------------
C
C... imprint the zone codes onto the IBOUND array
      DO 61 K=1,NLAY
      DO 61 I=1,NROW
      DO 61 J=1,NCOL
61    IBOUND(J,I,K)= IBSTRT(J,I,K)*IBOUND(J,I,K)
 
 
60    CONTINUE

C
C--------------------  START PARTICLE LOOP  -----------------------
C
      IEND=0
      DO 70 N=1,NPRT
C
C  SET START TIME FOR PARTICLE
C
      TIME=TOLD
 
C  IF RUN IS FORWARD MODE, CHECK TO SEE IF PARTICLE IS ACTIVE OR READY
C  TO BE RELEASED.
cjed ALLOW MULTIPLE RELEASE TIMES WITH BACKWARD TRACKING
cjed  ADDED .OR.IREV.EQ.1 TO 
      IF(IREV.EQ.0.OR.IREV.EQ.1) THEN
        IF(TOT(N).EQ.-1.0E+30) THEN
          NODE=INILOC(N)

          CALL RELEAS(N,TOT(N),ZTOP,ZBOT,HEAD,LAYCON,ZLC(N),ZLLC(N),
     1         NODE,NZDIM,NCOL,NROW,NLAY,TIME,TMAX,I5,I7,IGRID,
cjed   ADD PARTICLE INDEX VARIABLE NPARTC
cjed     2         HDRY,HNOFLO,IPSTAT,NSTEP)
     2         HDRY,HNOFLO,IPSTAT,NSTEP,NPARTC(N),IDMODSTART(N),
     3         PART_ASSOC(N))
        END IF
      END IF
C  IF PARTICLE HAS DISCHARGED, SKIP TO THE NEXT PARTICLE
      IF(TOT(N).GE.0.0E+0) GO TO 70
 
C  IF PARTICLE IS UNRELEASED, SKIP TO THE NEXT PARTICLE
      IF(TOT(N).EQ.-1.0E+30) THEN
        IF(IPSTAT.EQ.1) IEND=IEND+1
        GO TO 70
      END IF

C  IF IT GETS THIS FAR, THEN THERE IS AT LEAST 1 ACTIVE PARTICLE TO TRACK
C  THROUGH THIS PASS THROUGH THE TIME LOOP. SET NSTEPC=NSTEP TO MAKE SURE
C  THAT NSTEPC WILL CONTAIN THE VALUE THAT NSTEP HAD DURING THE FINAL PASS
C  THROUGH THE TIME LOOP
C
      NSTEPC=NSTEP
C  MOVE PARTICLE AS FAR AS IT CAN GO THIS PASS THROUGH THE TIME LOOP
C
      CALL FLOLIN (N,IGRID,MODE,TIME,TMAX,IDSCH,
     1JLC(N),ILC(N),KLC(N),XLC(N),YLC(N),ZLC(N),ZLLC(N),IBOUND,LAYCON,
     2ZBOT,ZTOP,XMAX,YMAX,QX,QY,QZ,DELC,DELR,POR,HEAD,NCON,NCOL,NROW,
     3NLAY,NLPOR,NZDIM,NCP1,NRP1,NLP1,ISNK,IREV,FRAC,IZSTOP,I2,
cjed  ADD PARTICLE INDEX NUMBER NPARTC, MODEL IDENTIFIER IDMODEL,XYZ OFFSETS
cjed  ADD OUTPUT UNIT NOS FOR GLOBAL OUTPUT FILES IUOUTEP,IUOUTTS,IUOUTPL,IUOUTPROJ
cjed     4I7,QSS,QSTO,INILOC,NPART,ISS,ICASE,HDRY,NSTEP,ICMPCT)
     4I7,QSS,QSTO,INILOC,NPART,ISS,ICASE,HDRY,NSTEP,ICMPCT,IUNIT(18),
     5NPARTC(N),IUOUTEP,IUOUTEPGL,IUOUTTS,IUOUTPL,IUOUTPROJ,
     6IDMODSTART(N),IDMODEL,XOFF,YOFF,ZOFF,ISLGR,IBFLG,NGRIDS,
     7PART_ASSOC(N))
cjed
C  ASSIGN TIME OF TRAVEL TO TOT ARRAY IF PARTICLE HAS DISCHARGED
C
cjed start addition
C  IDSCH = -3 -- PARTICLE WAS STOPPED AT A LGR BOUNDARY
cjed end addtion
C  IDSCH = -2 -- PARTICLE WAS STOPPED IN AUTOMATIC DISCHARGE ZONE
C  IDSCH = -1 -- PARTICLE WAS STRANDED IN INACTIVE CELL
C  IDSCH =  0 -- PARTICLE HAS DISCHARGED NORMALLY
C  IDSCH =  1 -- PARTICLE HAS NOT DISCHARGED
C

      IF(IDSCH.LE.0) THEN
      TOT(N)=TIME
cjed  ADD PARTICLE INDEX VARIABLE NPARTC, MODEL IDENTIFIER IDMODEL
cjed      READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NDUMMY
      READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NDUMMY,
c     1 NPARTSTRT,IDMODEL_START,ZSTRT,PARTASSOC   ! 1-12-11 move ZSTRT to end   
     1 NPARTSTRT,IDMODEL_START,PARTASSOC,ZSTRT
     
       NPARTC(N)=NPARTSTRT
       IDMODSTART(N)=IDMODEL_START
       PART_ASSOC(N)=PARTASSOC
cjed
      IF(IDSCH.EQ.0) IPCODE=  1 + (10*NSTEP)
      IF(IDSCH.EQ.-1) IPCODE= -1
      IF(IDSCH.EQ.-2) IPCODE= 2 + (10*NSTEP)
cjed start addition
      IF(IDSCH.EQ.-3) IPCODE= 3 + (10*NSTEP)
cjed  ADD PARTICLE INDEX VARIABLE NPARTC, MODEL IDENTIFIER IDMODEL
cjed      WRITE(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NDUMMY
      WRITE(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NDUMMY,
c     1 NPARTC(N),IDMODSTART(N),ZSTRT,PART_ASSOC(N) ! 1-12-11 move ZSTRT to end  
     1 NPARTC(N),IDMODSTART(N),PART_ASSOC(N),ZSTRT
cjed    
      ELSE
      IEND=IEND+1
      END IF
C
cjed  ADD LINE TO READ PARTICLE INDEX NUMBER and DUMMY IN ZSTRT POSITION
      READ(I5,REC=N) DUMMY,DUMMY,DUMMY,NDUMMY,DUMMY,NDUMMY,NPARTC(N),
c     1 IDMODSTART(N),DUMMY,PART_ASSOC(N) ! 1-12-11 move DUMMY to end
     1 IDMODSTART(N),PART_ASSOC(N),DUMMY
Cjed  END ADDITION

C  DON'T WRITE RESULTS IN TIMESERIES FILE FOR TIME=TMAX IF PARTICLE
C  DISCHARGED AT TIME < TMAX.
C
c      IF(IDSCH.LE.0.AND.TIME.LT.TMAX) GO TO 70
      IF(IDSCH.LE.0.AND.TIME.LT.TMAX) GO TO 69
C
C  WRITE RESULTS TO TIMESERIES FILE
C
      IF (MODE.EQ.2 .AND. ICASE.GT.1) THEN

cjed  ADD PARTICLE INDEX NUMBER NPARTC, MODEL IDENTIFIER IDMODEL      
cjed        CALL WRITTS(I4,ICMPCT,KOUNT,N,JLC(N),ILC(N),KLC(N),XLC(N),
cjed     1   YLC(N),ZLC(N),ZLLC(N),TMAX,NSTEP,NROW,NCOL)
        CALL WRITTS(I4,IUOUTTS,ISLGR,IDMODSTART(N),IDMODEL,ICMPCT, ! 1-12-11 change IDMODEL_START TO IDMODSTART(N)
     1   KOUNT,N,JLC(N),ILC(N),KLC(N),XLC(N),YLC(N),ZLC(N),ZLLC(N),TMAX,
     2   NSTEP,NROW,NCOL,NPARTC(N),XOFF,YOFF,ZOFF,PART_ASSOC(N))
cjed
      END IF
C
cjed add particle projection for observations from MPATH5.0
C  Interpolate outside the grid if using ADVOBS
69      if(MODE.EQ.2 .and. idsch.EQ.0 .AND. IUNIT(18).GT.0) THEN
          if(tote(N).EQ.0.) then
            tote(N)=tot(N)
            xlce(N)=xlc(N)
            ylce(N)=ylc(N)
            zlce(N)=zlc(N)
          end if
          XLCe(N)=XLCe(N)+VXE(N)*(TMAX-TOTE(N))
          YLCe(N)=YLCe(N)+VYE(N)*(TMAX-TOTE(N))
          ZLCe(N)=ZLCe(N)+VZE(N)*(TMAX-TOTE(N))
          TOTE(N)=TMAX
        end if
C  Write ADVOBS file if conditions are met.
        if(mode.eq.2 .AND. icase.gt.1 .AND. TOT(N).NE.-1.E30 .AND.
     1     IUNIT(18).GT.0 .AND. KOUNT.LE. MAXSTP)
     2      CALL ADVOBSOT(N,IDSCH,TIME,TOT(N),XLCE(N),YLCE(N),
     3          ZLCE(N),TOTE(N),VXE(N),VYE(N),VZE(N),
     4          XLC(N),YLC(N),ZLC(N),IUNIT(18),ICMPCT,ISLGR,XOFF,YOFF,
     5          IUOUTPROJ,NPARTC(N),PART_ASSOC(N),IDMODEL,IDMODSTART(N))

70    CONTINUE
C
C  Keep going until all time steps are completed when
C    (1) the mode is Time Series (MODE=2),
C    (2) there are 0 active particles (IEND=0), and
C    (3) ADVOBS is active (IUNIT(18)>0).
         if(mode.eq.2 .and. iend.eq.0 .and. iunit(18).gt.0) then
           if(kount.lt.maxstp) iend=1
         end if
         
      IF(IEND.EQ.0) GO TO 71
        IF(ISTOP.LT.0) THEN
          ISTOP=1
          GO TO 71
        END IF
 
C... if we are entering a new modflow time step on the next pass through the
C    time loop, then get new flow rates.
      IF(ICASE.EQ.1 .OR. ICASE.EQ.3) THEN
 
        IF(ISS.EQ.1) THEN
          ISTOP=1
          GO TO 71
        END IF
 
        IF(IREV.EQ.1) THEN
          NSTEP=NSTEP-1
        ELSE
          NSTEP=NSTEP+1
        END IF
 
C... STOP IF WE HAVE REACHED THE END OF THE CBF
        IF(NSTEP.LT.NSTEPF .OR. NSTEP.GT.NSTEPL) THEN
          ISTOP=1
          GO TO 71
        END IF

        CALL READHQ(QX,QY,QZ,QSS,QSTO,HEAD,IBOUND,BUFF,NCOL,
     1  NROW,NLAY,NCP1,NRP1,NLP1,I10,NSTEP,DTSTP,TOTSIM,IERR,
     2  NUMTS,NPER,NSTEPF,NSTEPL,KPER,KSTP,1,I7)
 
        IF(IERR.NE.0) THEN
          ISTOP=1
          WRITE(I7,9100) NSTEP
9100      FORMAT(1X,'ERROR READING COMPOSITE BUDGET FILE:',
     1           /10X,'CUMULATIVE TIME STEP = ',I6)
          GO TO 71
        END IF
        WRITE(I7,9200) NSTEP
9200    FORMAT(1X,'NEW MODFLOW TIME STEP: DATA READ FROM CBF; CUMULATIVE
     1 TIME STEP = ',I6)
 
        IF(IREV.EQ.1) THEN
          CALL FLIPQ(QX,QY,QZ,NCOL,NROW,NLAY,NCP1,NRP1,NLP1)
        END IF
 
        TIMSTP=TIMSTP+DTSTP
        IF(TSTOP.LE.TIMSTP) THEN
          ISTOP= -1
          TIMSTP=TSTOP
        END IF
 
C... IMPRINT THE ZONE CODES ONTO THE IBOUND ARRAY
      DO 62 K=1,NLAY
      DO 62 I=1,NROW
      DO 62 J=1,NCOL
62    IBOUND(J,I,K)= IBSTRT(J,I,K)*IBOUND(J,I,K)
 
      END IF
 
C... set the end time for the next pass through the time loop and
C    determine if it will be necessary to load new flows at the end
C    of the pass. get the new request time if necessary.
      IF(ICASE.EQ.2 .OR. ICASE.EQ.3) THEN
        KOUNT=KOUNT+1
        CALL GETREQ(ITMS,ITREAD,MAXSTP,KOUNT,DELT,TFAC,TIMREQ,I8)
      END IF
      TOLD=TMAX
      IF(TIMREQ.GT.TIMSTP) THEN
      ICASE=1
      TMAX=TIMSTP
      ELSE IF(TIMREQ.LT.TIMSTP) THEN
      ICASE=2
      TMAX=TIMREQ
      IF(ISTOP.LT.0) ISTOP=0
      ELSE IF(TIMREQ.EQ.TIMSTP) THEN
      ICASE=3
      TMAX=TIMSTP
      END IF
C
71    CONTINUE
C-------------------  END PARTICLE LOOP  -------------------------
C
C  CHECK TO SEE IF ALL PARTICLES HAVE DISCHARGED. IF NOT GO THROUGH
C  TIME LOOP AGAIN.
C
      IF(IEND.GT.0.AND.ISTOP.NE.1) GO TO 60
      IF(ISTOP.EQ.1) THEN
      DO 75 N=1,NPRT
      IF(TOT(N).LT.0.0 .AND. TOT(N).NE.-1.0E+30) TOT(N)= TMAX
75    CONTINUE
      END IF
C
C----------------------  END TIME LOOP  ---------------------------
C
C  WRITE DISCHARGE DATA TO ENDPOINT  FILE
C
      IACTIV=0
      ISTRAN=0
      ISTOPD=0
      ISTOPLGR=0
      IDCH=0
      IUNREL=0
 
C  WRITE VERSION HEADER AS FIRST LINE OF ENDPOINT FILE
      CALL FILHDR(I3,VER,ICMPCT,TBGABS)
 
      TIMMIN=1.0E+30
      TIMMAX=0.0
      KNTPTS=0
      TIMSUM=0.0
      DO 80 N=1,NPRT
      NN=N
cjed  ADD PARTICLE INDEX NUMBER NPARTSTRT and ZSTRT
cjed      READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NSFRST
      READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NSFRST,NPARTSTRT,
c     1 IDMODEL_START,ZSTRT,PARTASSOC ! 1-12-11 move ZSTRT to end      
     1 IDMODEL_START,PARTASSOC,ZSTRT
      NPARTC(N)=NPARTSTRT
      IDMODSTART(N)=IDMODEL_START
      PART_ASSOC(N)=PARTASSOC
cjed
      IF(IPCODE.GE.0) THEN
        IDCODE= MOD(IPCODE,10)
      ELSE
        IDCODE= IPCODE
      END IF
      NODE=INILOC(N)
      IF(NODE.LT.0) NODE= -NODE
      CALL ND2IJK(NODE,IFRST,JFRST,KFRST,NROW,NCOL)
      IF(IDCODE.EQ.0) THEN
        IACTIV=IACTIV+1
      ELSE IF(IDCODE.EQ.1) THEN
        IDCH=IDCH+1
      ELSE IF(IDCODE.EQ.-1) THEN
        ISTRAN=ISTRAN+1
      ELSE IF(IDCODE.EQ.2) THEN
        ISTOPD=ISTOPD+1
cjed start addition
      ELSE IF(IDCODE.EQ.3) THEN
        ISTOPLGR=ISTOPLGR+1
cjed end addition
      ELSE IF(IDCODE.EQ.-2) THEN
        IUNREL=IUNREL+1
      END IF
C
C  WRITE DISCHARGE INFO TO SUMMARY FILE FOR 1ST 1000 PARTICLES IF IOP=1
C
      IF(IOP.EQ.1) THEN
      IF(N.EQ.1) THEN
      WRITE(I7,*) ' '
      WRITE(I7,*)' ******** PARTICLE TERMINATION INFORMATION'
      END IF
      IF(N.LE.1000) THEN
        IF(IDCODE.EQ.2) THEN
cjed    ADD PARTICLE INDEX VARIABLE NPARTC
cjed          WRITE (I7,5010) N,ILC(N),JLC(N),KLC(N),TOT(N)
          WRITE (I7,5010) N,NPARTC(N),ILC(N),JLC(N),KLC(N),TOT(N)
cjed
        ELSE IF(IDCODE.EQ.1) THEN
cjed    ADD PARTICLE INDEX VARIABLE NPARTC
cjed          WRITE (I7,5013) N,ILC(N),JLC(N),KLC(N),TOT(N)
          WRITE (I7,5013) N,NPARTC(N),ILC(N),JLC(N),KLC(N),TOT(N)
cjed
        ELSE IF(IDCODE.EQ.-1) THEN
cjed    ADD PARTICLE INDEX VARIABLE NPARTC
cjed          WRITE (I7,5012) N,ILC(N),JLC(N),KLC(N),TOT(N)
          WRITE (I7,5012) N,NPARTC(N),ILC(N),JLC(N),KLC(N),TOT(N)
cjed
        ELSE IF(IDCODE.EQ.0) THEN
cjed    ADD PARTICLE INDEX VARIABLE NPARTC
cjed          WRITE (I7,5011) N,ILC(N),JLC(N),KLC(N),TOT(N)
          WRITE (I7,5011) N,NPARTC(N),ILC(N),JLC(N),KLC(N),TOT(N)
cjed
        ELSE IF(IDCODE.EQ.-2) THEN
cjed    ADD PARTICLE INDEX VARIABLE NPARTC
cjed          WRITE (I7,5014) N,ILC(N),JLC(N),KLC(N),TOT(N)
          WRITE (I7,5014) NPARTC(N),ILC(N),JLC(N),KLC(N),TOT(N)
cjed
        END IF
      ELSE IF(N.EQ.1001) THEN
        WRITE(I7,*)
     1'***** DATA SUMMARIZED FOR FIRST 1000 PARTICLES ONLY ****'
        END IF
      END IF
C
      IZONE=IBOUND(JLC(N),ILC(N),KLC(N))
      IF(IZONE.LT.0) IZONE=-IZONE
      IF(IZONE.GE.1000) IZONE=IZONE/1000
      IZONE2=IBOUND(JFRST,IFRST,KFRST)
      IF(IZONE2.LT.0) IZONE2=-IZONE2
      IF(IZONE2.GE.1000) IZONE2=IZONE2/1000
 
C  WRITE ENDPOINT DATA FOR A PARTICLE
      IF(IPCODE.EQ.0) IPCODE= 10*NSTEPC
      IF (IPEP.EQ.0) THEN
        IF(TOT(N).GE.0.0 .AND. IPCODE.NE.-2) THEN
          KNTPTS=KNTPTS+1
          TIMSUM=TIMSUM+(TOT(N)-TRLEAS)
          IF(TOT(N)-TRLEAS.LT.TIMMIN) TIMMIN=TOT(N)-TRLEAS
          IF(TOT(N)-TRLEAS.GT.TIMMAX) TIMMAX=TOT(N)-TRLEAS
        END IF
        ISKIP=0
cjed   REMOVE REQUIREMENT OF IPCODE NE -2 FOR WRITING TO ENDPOINT FILE        
c        IF(TOT(N).LT.0.0) ISKIP=1
        IF(TOT(N).LT.0.0 .OR. IPCODE.EQ.-2) ISKIP=1
cjed    end addition
        IF(MODE.GT.0) ISKIP=0
        IF(ISKIP.EQ.0) THEN
cjed cswm        CALL WRITEP(I3,ICMPCT,IZONE,JLC(N),ILC(N),KLC(N),XLC(N),
cjed    undo change by swm and rename IP to NPARTC, ADD MODEL IDENTIFIER IDMODEL
cjed         CALL WRITEP(I3,ICMPCT,NN,IZONE,JLC(N),ILC(N),KLC(N),XLC(N), !added N to output

         CALL WRITEP(I3,IUOUTEP,IUOUTEPGL,ISLGR,IDMODSTART(N),IDMODEL,
     1    ICMPCT,NPARTC(N),IZONE,JLC(N),ILC(N),KLC(N),
     2    XLC(N),YLC(N),ZLLC(N),ZLC(N),TOT(N),XSTRT,YSTRT,ZLSTRT,
     3    JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS, NROW,NCOL,
     4    XOFF,YOFF,ZOFF,ZSTRT,PART_ASSOC(N))
     
        END IF
      ELSE IF(IZONE.EQ.IZSTOP) THEN
        IF(TOT(N).GE.0.0 .AND. IPCODE.NE.-2) THEN
          KNTPTS=KNTPTS+1
          TIMSUM=TIMSUM+(TOT(N)-TRLEAS)
          IF(TOT(N)-TRLEAS.LT.TIMMIN) TIMMIN=TOT(N)-TRLEAS
          IF(TOT(N)-TRLEAS.GT.TIMMAX) TIMMAX=TOT(N)-TRLEAS
        END IF
        ISKIP=0
cjed   REMOVE REQUIREMENT OF IPCODE NE -2 FOR WRITING TO ENDPOINT FILE  
c        IF(TOT(N).LT.0.0) ISKIP=1        
        IF(TOT(N).LT.0.0 .OR. IPCODE.EQ.-2) ISKIP=1
cjed    end addition
        IF(MODE.GT.0) ISKIP=0
        IF(ISKIP.EQ.0) THEN

cjed cswm        CALL WRITEP(I3,ICMPCT,IZONE,JLC(N),ILC(N),KLC(N),XLC(N),
cjed    undo change by swm and rename IP to NPARTC, ADD MODEL IDENTIFIER IDMODEL
cjed        CALL WRITEP(I3,ICMPCT,NN,IZONE,JLC(N),ILC(N),KLC(N),XLC(N),  !added N to output 

       CALL WRITEP(I3,IUOUTEP,IUOUTEPGL,ISLGR,IDMODSTART(N),IDMODEL,
     1   ICMPCT,NPARTC(N),IZONE,JLC(N),ILC(N),KLC(N),
     2   XLC(N),YLC(N),ZLLC(N),ZLC(N),TOT(N),XSTRT,YSTRT,ZLSTRT,
     3   JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS, NROW,NCOL,
     4   XOFF,YOFF,ZOFF,ZSTRT,PART_ASSOC(N))
     
        END IF
      END IF
 
80    CONTINUE
      TIMAVE=0.
      IF(KNTPTS.GT.0) TIMAVE= TIMSUM/FLOAT(KNTPTS)
      KNTPT2=0
      DO 81 N=1,NPRT
cjed  ADD PARTICLE INDEX VARIABLE NPARTC and ZSTRT     
cjed        READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NSFRST
        READ(I5,REC=N) XSTRT,YSTRT,ZLSTRT,IPCODE,TRLEAS,NSFRST,
c     1   NPARTSTRT,IDMODEL_START,ZSTRT,PARTASSOC ! 1-12-11 move zstrt to end
     1   NPARTSTRT,IDMODEL_START,PARTASSOC,ZSTRT
         NPARTC(N)=NPARTSTRT
         IDMODSTART(N)=IDMODEL_START
         PART_ASSOC(N)=PARTASSOC
cjed    
        IF(IPCODE.GE.0) THEN
          IDCODE= MOD(IPCODE,10)
        ELSE
          IDCODE= IPCODE
        END IF
        IF(IPEP.GT.0 .AND. IDCODE.NE.2) GO TO 81
        IF(TOT(N).GE.0.0 .AND. IPCODE.NE.-2) THEN
          IF(TOT(N)-TRLEAS.LE.TIMAVE) KNTPT2=KNTPT2+1
        END IF
81    CONTINUE
      TIMFR=0.0
      IF(KNTPT2.GT.0) TIMFR= 100.*FLOAT(KNTPT2)/FLOAT(KNTPTS)
cjed     ISUM=IACTIV+IDCH+ISTOPD+ISTRAN
cjed start addition
        ISUM=IACTIV+IDCH+ISTOPD+ISTRAN+ISTOPLGR
cjed end addition        
      IF(IREV.EQ.0) ISUM=ISUM+IUNREL
      IF(ISILNT.EQ.0) THEN
        WRITE(*,*)
        IF(IPEP.EQ.0) THEN
          WRITE(*,5036)
        ELSE IF(IPEP.GT.0) THEN
          WRITE(*,5037) IZSTOP
        END IF
        WRITE(*,5034) TIMMIN,TIMMAX,TIMAVE
        WRITE(*,5035) TIMFR
        WRITE(*,*)
        IF(IREV.EQ.0) THEN
cjed added ISTOPLGR        
          WRITE(*,5032) IACTIV,IDCH,ISTOPD,ISTOPLGR,ISTRAN,IUNREL,ISUM,
     1    NPRT
        ELSE
cjed added ISTOPLGR
          WRITE(*,5031) IACTIV,IDCH,ISTOPD,ISTOPLGR,ISTRAN,ISUM,NPRT
        END IF
      END IF
 
      WRITE(I7,*) '   '
      IF(IPEP.EQ.0) THEN
        WRITE(I7,5036)
      ELSE IF(IPEP.GT.0) THEN
        WRITE(I7,5037) IZSTOP
      END IF
      WRITE(I7,5034) TIMMIN,TIMMAX,TIMAVE
      WRITE(I7,5035) TIMFR
      WRITE(I7,*) '   '
      IF(IREV.EQ.0) THEN
        WRITE(I7,5032) IACTIV,IDCH,ISTOPD,ISTOPLGR,ISTRAN,IUNREL,ISUM,
     1   NPRT
      ELSE
        WRITE(I7,5031) IACTIV,IDCH,ISTOPD,ISTOPLGR,ISTRAN,ISUM,NPRT
      END IF
cjed  ADD PARTICLE INDEX VARIABLE NPARTC 
cjed5010  FORMAT(' PARTICLE ',I6,'  WAS STOPPED IN ROW ',I3,', COL ',I3,
cjed     1', LAY ',I3,'  TIME= ',1PE11.4)
cjed5011  FORMAT(' PARTICLE ',I6,'    IS ACTIVE IN ROW ',I3,', COL ',I3,
cjed     1', LAY ',I3,'  TIME= ',1PE11.4)
cjed5012  FORMAT(' PARTICLE ',I6,' WAS STRANDED IN ROW ',I3,', COL ',I3,
cjed     1', LAY ',I3,'  TIME= ',1PE11.4)
cjed5013  FORMAT(' PARTICLE ',I6,'        EXITS IN ROW ',I3,', COL ',I3,
cjed     1', LAY ',I3,'  TIME= ',1PE11.4)
5010  FORMAT(' PARTICLE ',I6,'   OF ATTRIBUTE ', I6,
     1'  WAS STOPPED IN ROW ',I3,', COL ',I3,', LAY ',I3,
     2'  TIME= ',1PE11.4)
5011  FORMAT(' PARTICLE ',I6,'   OF ATTRIBUTE ', I6,
     1'    IS ACTIVE IN ROW ',I3,', COL ',I3,
     2', LAY ',I3,'  TIME= ',1PE11.4)
5012  FORMAT(' PARTICLE ',I6,'   OF ATTRIBUTE ', I6,
     1' WAS STRANDED IN ROW ',I3,', COL ',I3,
     2', LAY ',I3,'  TIME= ',1PE11.4)
5013  FORMAT(' PARTICLE ',I6,'   OF ATTRIBUTE ', I6,
     1'        EXITS IN ROW ',I3,', COL ',I3,
     2', LAY ',I3,'  TIME= ',1PE11.4)
cjed

5014  FORMAT(' PARTICLE ',I6,' WAS NOT RELEASED')
5030  FORMAT(4(1X,I4),8(1X,E13.6),4(1X,I4),I3,1X,E13.6)
5031  FORMAT(1X,I7,' PARTICLES REMAIN ACTIVE'/
     11X,I7,' PARTICLES STOPPED AT INTERNAL SINKS/SOURCES OR BOUNDARIES'
     2/1X,I7,' PARTICLES STOPPED IN AN AUTOMATIC TERMINATION ZONE'/
cjed start addition
     31X,I7,' PARTICLES STOPPED AT A LGR GRID BOUNDARY'/
cjed end addition     
     31X,I7,' PARTICLES WERE STRANDED IN INACTIVE CELLS'/
     41X,'-----'/1X,I7,' PARTICLES ACCOUNTED FOR OUT OF A TOTAL OF ',I7)
5032  FORMAT(1X,I7,' PARTICLES REMAIN ACTIVE'/
     11X,I7,' PARTICLES STOPPED AT INTERNAL SINKS/SOURCES OR BOUNDARIES'
     2/1X,I7,' PARTICLES STOPPED IN AN AUTOMATIC TERMINATION ZONE'/
cjed start addition
     31X,I7,' PARTICLES STOPPED AT A LGR GRID BOUNDARY'/
cjed end addition 
     31X,I7,' PARTICLES WERE STRANDED IN INACTIVE CELLS'/
     41X,I7,' PARTICLES WERE NOT RELEASED'/
     41X,'-----'/1X,I7,' PARTICLES ACCOUNTED FOR OUT OF A TOTAL OF ',I7)
5034  FORMAT(1X,'MINIMUM TRAVEL TIME = ',1PE13.5/1X,'MAXIMUM TRAVEL TIME
     1 = ',E13.5/1X,'AVERAGE TRAVEL TIME = ',E13.5)
5035  FORMAT(1X,F6.1,'% OF THE PARTICLES HAD TRAVEL TIMES LESS THAN THE
     1 AVERAGE TRAVEL TIME')
5036  FORMAT(1X,'TRAVEL TIME SUMMARY FOR ALL PARTICLES:')
5037  FORMAT(1X,'TRAVEL TIME SUMMARY FOR PARTICLES TERMINATING IN ZONE',
     11X,I4,':')
C
6000  FORMAT(A4,A,A2)
      RETURN
      END

      SUBROUTINE ADVOBSOT(N,IDSCH,TIME,TOT,XLCE,YLCE,ZLCE,TOTE,
     1             VXE,VYE,VZE,XLC,YLC,ZLC,I18,ICMPCT,ISLGR,XOFF,YOFF,
     2             IUOUTPROJ,NPARTC,PARTASSOC,IDMODEL,IDMODEL_START)
C  Write data into ADVOBS file
C
      IMPLICIT NONE
      
      INTEGER N,IDSCH,I18,ICMPCT,ISLGR,IUOUTPROJ,NPARTC,IDMODEL
      INTEGER IDMODEL_START
      
      REAL TIME,TOT,XLCE,YLCE,ZLCE,TOTE,VXE,VYE,VZE
      REAL XLC,YLC,ZLC,XOFF,YOFF,CXOFF,CYOFF,CXOFFE,CYOFFE
      CHARACTER*40 PARTASSOC

      IF(ISLGR.EQ.1) THEN
C     DETERMINE OFFSETS FOR CHILD MODEL FOR GLOBAL PROJECTION FILE      
          CXOFF =XLC +XOFF
          CYOFF =YLC +YOFF
          CXOFFE=XLCE+XOFF
          CYOFFE=YLCE+YOFF
      END IF
!      IF(ICMPCT.EQ.2) THEN ! binary format      
!         IF(TOT.GE.0.) THEN
!C  Write projected data -- TOT is greater than 0 only after particle discharges.
!            WRITE(I18) N,IDSCH,XLCE,YLCE,ZLCE,TOTE,VXE,VYE,VZE, ! output for single model
!     1       PARTASSOC  ! 1-11-11 add IDMODEL_START and IDMODEL
!         ELSE
!C  Write non-projected data.
!            WRITE(I18) N,IDSCH,XLC,YLC,ZLC,TIME,VXE,VYE,VZE,  ! output for single model
!     1       PARTASSOC ! 1-11-11 add IDMODEL_START and IDMODEL
!         END IF 
!         IF(ISLGR.EQ.1) THEN ! more than one model?
!              IF(IDMODEL.EQ.1) THEN ! parent model
!                  IF(TOT.GE.0.) THEN
!C                 Write projected data
!                     WRITE(IUOUTPROJ) N,IDSCH,XLCE,YLCE,ZLCE,TOTE,VXE,   ! global projection file
!     1                VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC
!                  ELSE
!C                 Write non-projected data.
!                     WRITE(IUOUTPROJ) N,IDSCH,XLC,YLC,ZLC,TIME,VXE,VYE,
!     1               VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC ! 1-11-11 add IDMODEL_START and IDMODEL
!                  END IF
!              ELSE IF(IDMODEL.GT.1) THEN ! child model
!                  IF(TOT.GE.0.) THEN
!C                 Write projected data
!                     WRITE(IUOUTPROJ) N,IDSCH,CXOFFE,CYOFFE,ZLCE,TOTE,   ! global projection file
!     1                VXE,VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC
!                  ELSE
!C                 Write non-projected data.
!                     WRITE(IUOUTPROJ) N,IDSCH,CXOFF,CYOFF,ZLC,TIME,VXE,
!     1               VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC ! 1-11-11 add IDMODEL_START and IDMODEL              
!                  END IF
!              END IF
!         END IF     
!
!      ELSE ! standard format
         IF(TOT.GE.0.) THEN
C  Write projected data -- TOT is greater than 0 only after particle discharges.
            WRITE(I18,100) N,IDSCH,XLCE,YLCE,ZLCE,TOTE,VXE,VYE,VZE, ! output for single model
     1       PARTASSOC  ! 1-11-11 add IDMODEL_START and IDMODEL
         ELSE
C  Write non-projected data.
            WRITE(I18,100) N,IDSCH,XLC,YLC,ZLC,TIME,VXE,VYE,VZE,     ! output for single model
     1       PARTASSOC ! 1-11-11 add IDMODEL_START and IDMODEL
         END IF 
         IF(ISLGR.EQ.1) THEN ! more than one model?
              IF(IDMODEL.EQ.1) THEN ! parent model
                  IF(TOT.GE.0.) THEN
C                 Write projected data
                     WRITE(IUOUTPROJ,110) N,IDSCH,XLCE,YLCE,ZLCE,TOTE,   ! global projection file
     1                VXE,VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC

                  ELSE
C                 Write non-projected data.
                     WRITE(IUOUTPROJ,110) N,IDSCH,XLC,YLC,ZLC,TIME,VXE,
     1               VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC ! 1-11-11 add IDMODEL_START and IDMODEL

                  END IF
              ELSE IF(IDMODEL.GT.1) THEN ! child model
                  IF(TOT.GE.0.) THEN
C                 Write projected data
                     WRITE(IUOUTPROJ,110) N,IDSCH,CXOFFE,CYOFFE,ZLCE,   ! global projection file
     1                TOTE,VXE,VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,
     2                PARTASSOC

                  ELSE
C                 Write non-projected data.
                     WRITE(IUOUTPROJ,110) N,IDSCH,CXOFF,CYOFF,ZLC,TIME,
     1               VXE,VYE,VZE,IDMODEL_START,IDMODEL,NPARTC,PARTASSOC ! 1-11-11 add IDMODEL_START and IDMODEL              

                  END IF
              END IF
         END IF 
!      END IF
      
 100  FORMAT(1X,I5,1X,I3,1X,3E14.6,5X,E14.6,5X,3E14.6,3X,A)
 110  FORMAT(1X,I5,1X,I3,1X,3E14.6,5X,E14.6,5X,3E14.6,1X,3I10,3X,A)
      RETURN
      END