C MODPATH Version 3.00 (V3, Release 2, 5-99)
C Changes:
C   No change since previous release: (V3, Release 1, 9-94)
C***** SUBROUTINES *****
C     FILHDR
C     WRITEP
C     WRITTS
C     WRITPL
C     WRITSCRATCH
C***********************

C***** SUBROUTINE *****
      SUBROUTINE FILHDR(IU,VER,ICMPCT,TREF)
      CHARACTER*(*) VER
      CHARACTER*10 STYLE
      CHARACTER*4 LEFT
      CHARACTER*2 RIGHT
      CHARACTER*80 LINE
C
      LINE=VER
      LEFT= '@ [ '
      RIGHT= ' ]'
      IF(ICMPCT.LT.2) THEN
        IF(ICMPCT.EQ.1) THEN
          STYLE= '(COMPACT)'
          CALL CHOP(STYLE,LS)
        ELSE
          LS=1
          STYLE= ' '
        END IF
        CALL CHOP(VER,LV)
        REWIND(IU)
        WRITE(IU,1000) LEFT,VER(1:LV),STYLE(1:LS),TREF,RIGHT
1000    FORMAT(A4,A,A,'(TREF=',E15.6,' )',A2)
 
      ELSE IF(ICMPCT.EQ.2) THEN
        REWIND(IU)
        WRITE(IU) LINE,TREF
      END IF
 
      RETURN
      END
 
C***** SUBROUTINE *****
cjed cswm:  Added particle number to output (IP), MODEL IDENTIFIER IDMODEL
cjed  ADD UNIT NUMBER IUOUTEP FOR INTERNAL STORAGE OF ENDPOINTS 
cjed  ADD UNIT NUMBER IUOUTEPGL FOR GLOBAL ASCII OUTPUT FOR EACH TIME STEP
cjed cswm      SUBROUTINE WRITEP(IU,ICMPCT,IZONE,J,I,K,X,Y,ZL,Z,TOT,XSTRT,
cjed  delete change by swm and rename IP to NPARTVAL
cjed      SUBROUTINE WRITEP(IU,ICMPCT,IP,IZONE,J,I,K,X,Y,ZL,Z,TOT,XSTRT,
       SUBROUTINE WRITEP(IU,IUOUTEP,IUOUTEPGL,ISLGR,IDMODEL_START,
     1  IDMODEL,ICMPCT,NPARTVAL,IZONE,J,I,K,X,Y,ZL,Z,TOT,XSTRT,YSTRT,
     2  ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,NROW,NCOL,
     3  XOFF,YOFF,ZOFF,ZSTRT,PARTASSOC)

      CHARACTER*40 PARTASSOC
      
      IF(ISLGR.EQ.1) THEN ! GET PARTICLE COORDINATES RELATIVE TO PARENT MODEL
          XREG_END=X+XOFF
          YREG_END=Y+YOFF
          XREG_START=XSTRT+XOFF
          YREG_START=YSTRT+YOFF
      END IF
         XNEW=X-XOFF        
         YNEW=Y-YOFF        
         ZGLOBNEW=ZGLOB
           
      IF(ICMPCT.EQ.1) THEN ! compact format
          ND = (K-1)*NROW*NCOL + (I-1)*NCOL + J
          NDFRST = (KFRST-1)*NROW*NCOL + (IFRST-1)*NCOL + JFRST

          WRITE(IU,1000) IZONE,ND,X,Y,ZL,TOT,XSTRT,YSTRT,ZLSTRT, ! endpoint for single model
     1     NDFRST,IZONE2,NSFRST,IPCODE,TRLEAS,NPARTVAL,PARTASSOC
 
         IF(ISLGR.EQ.1) THEN ! more than one model
            IF(IUOUTEP.GT.0) THEN
               IF(IDMODEL.EQ.1) THEN ! parent model
                  WRITE(IUOUTEP) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! internal storage of endpoints
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
                  WRITE(IUOUTEPGL,2010) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! global endpoint standard format
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
   
               ELSE IF(IDMODEL.GT.1) THEN ! child model
                  WRITE(IUOUTEP) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! internal storage of endpoints
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC

                  WRITE(IUOUTEPGL,2010) IZONE,J,I,K,             ! global endpoint standard format
     1             XREG_END,YREG_END,Z,ZL,TOT,XREG_START,YREG_START,
     2             ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,
     3             ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               END IF
            END IF
         END IF

1000      FORMAT(I3,1X,I6,1X,1PE12.5,6(1X,E12.5),1X,I6,1X,I3,1X,I5,1X,
     1         I6,1X,E12.5,1X,I6,1X,A)
1010      FORMAT(I3,1X,I6,1X,1PE12.5,6(1X,E12.5),1X,I6,1X,I3,1X,I5,1X,
     1         I6,2(1X,E12.5),3(1X,I6),1X,A)


      ELSE IF(ICMPCT.EQ.2) THEN ! binary format
         ND= (K-1)*NROW*NCOL + (I-1)*NCOL + J
         NDFRST= (KFRST-1)*NROW*NCOL + (IFRST-1)*NCOL + JFRST
         WRITE(IU) IZONE,ND,X,Y,ZL,TOT,XSTRT,YSTRT,ZLSTRT, ! endpoint for single model
     1    NDFRST,IZONE2,NSFRST,IPCODE,TRLEAS,NPARTVAL,PARTASSOC

         IF(ISLGR.EQ.1) THEN ! more than one model
            IF(IUOUTEP.GT.0) THEN
               IF(IDMODEL.EQ.1) THEN ! parent model
                  WRITE(IUOUTEP) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! internal storage of endpoints
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC

                  WRITE(IUOUTEPGL) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! binary/standard format
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC

               ELSE IF(IDMODEL.GT.1) THEN ! child model
                  WRITE(IUOUTEP) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! internal storage of endpoints
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC

                  WRITE(IUOUTEPGL) IZONE,J,I,K, ! binary/standard format
     1             XREG_END,YREG_END,Z,ZL,TOT,XREG_START,YREG_START,
     2             ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,
     3             ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               END IF
            END IF
         END IF

      ELSE ! standard format
         WRITE(IU,2000) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT,YSTRT,ZLSTRT, ! endpoint for single model
cjed cswm     1     JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS
cjed    delete change by swm and rename IP to NPARTNAM
cjed     1     JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,IP,ZSTRT  !added IP
     1     JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,ZSTRT,
     2     NPARTVAL,PARTASSOC
         IF(ISLGR.EQ.1) THEN ! more than one model?
            IF(IUOUTEP.GT.0) THEN
               IF(IDMODEL.EQ.1) THEN ! parent model
                  WRITE(IUOUTEP) IZONE,J,I,K,X,Y,Z,ZL, ! internal storage of endpoint
     1             TOT,XSTRT,YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,
     2             NSFRST,IPCODE,TRLEAS,ZSTRT,
     3              IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC 
                  WRITE(IUOUTEPGL,2010) IZONE,J,I,K,X,Y,Z,ZL,TOT,XSTRT, ! global endpoint
     1             YSTRT,ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,
     2             TRLEAS,ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               ELSE IF(IDMODEL.GT.1) THEN ! child model
                  WRITE(IUOUTEP) IZONE,J,I,K,X,Y,Z, ! internal storage of endpoints
     1             ZL,TOT,XSTRT,YSTRT,ZLSTRT,JFRST,IFRST,
     2             KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,ZSTRT,
     3             IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
                  WRITE(IUOUTEPGL,2010) IZONE,J,I,K, ! global endpoint
     1             XREG_END,YREG_END,Z,ZL,TOT,XREG_START,YREG_START,
     2             ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLEAS,
     3             ZSTRT,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               END IF
            END IF
         END IF      
cjed     
2000    FORMAT(I3,3(1X,I4),1X,1PE12.5,7(1X,E12.5),3(1X,I4),1X,I3,1X,I5,
cswm     1    1X,I6,1X,E12.5)
     1    1X,I6,1X,E12.5,1X,E12.5,1X,I6,1X,A)
2010    FORMAT(I3,3(1X,I4),1X,1PE12.5,7(1X,E12.5),3(1X,I4),1X,I3,1X,I5,
     1    1X,I6,2(1X,E12.5),3(1X,I6),1X,A)
cjed    END ADDITION
      END IF
      RETURN
      END
 
C***** SUBROUTINE *****
cjed  ADD PARTICLE INDEX NUMBER NPARTVAL, GRID IDENTIFIER IDMODEL
cjed  ADD UNIT NUMBER IUOUT FOR ADDITIONAL ASCII OUTPUT FOR EACH TIME STEP
cjed      SUBROUTINE WRITTS(IU,ICMPCT,MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP,
cjed     1                  NROW,NCOL)
      SUBROUTINE WRITTS(IU,IUOUTTS,ISLGR,IDMODEL_START,IDMODEL,ICMPCT,
     1              MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP,NROW,NCOL,NPARTVAL,
     2              XOFF,YOFF,ZOFF,PARTASSOC)
cjed  END ADDITIONS

      CHARACTER*40 PARTASSOC
      IF(ISLGR.EQ.1) THEN
          CXOFF=X+XOFF
          CYOFF=Y+YOFF
      END IF
      IF(ICMPCT.EQ.1) THEN ! compact format
         ND= (K-1)*NROW*NCOL + (I-1)*NCOL + J
         WRITE(IU,1000) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,NPARTVAL, ! output for single model
     1    PARTASSOC
!         IF(ISLGR.EQ.1) THEN ! more than one model?
!            IF(IUOUTTS.GT.0) THEN
!               IF(IDMODEL.EQ.1) THEN ! parent model
!                  WRITE(IUOUTTS,1010) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP, ! global time-series
!     1             IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
!               ELSE IF(IDMODEL.GT.1) THEN ! child model
!                  WRITE(IUOUTTS,1010) MPSTP,NP,ND,CXOFF,CYOFF,Z, ! global time-series
!     1             ZL,T,NSTEP,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
!               END IF
!            END IF
!         END IF
1000  FORMAT(I7,2(1X,I7),1X,1PE12.5,4(1X,E12.5),2(1X,I7),2X,A)        
1010  FORMAT(I7,2(1X,I7),1X,1PE12.5,4(1X,E12.5),4(1X,I7),2X,A)
cjed 
      ELSE IF(ICMPCT.EQ.2) THEN ! binary
         ND= (K-1)*NROW*NCOL + (I-1)*NCOL + J
         WRITE(IU) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,NPARTVAL, ! output for single model
     1    PARTASSOC
         IF(ISLGR.EQ.1) THEN ! more than one model?
            IF(IUOUTTS.GT.0) THEN
               IF(IMODEL.EQ.1) THEN ! parent model
                  WRITE(IUOUTTS) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP, ! global time-series
     1             IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               ELSE IF(IMODEL.GT.1) THEN ! child model
                  WRITE(IUOUTTS) MPSTP,NP,J,I,K,CXOFF,CYOFF,Z, ! global time-series
     1             ZL,T,NSTEP,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               END IF
            END IF
         END IF
      ELSE ! standard text format
         WRITE(IU,2000) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP,NPARTVAL, ! output for single model
     1    PARTASSOC
         IF(ISLGR.EQ.1) THEN ! more than one model?
            IF(IUOUTTS.GT.0) THEN
               IF(IDMODEL.EQ.1) THEN ! parent model
                  WRITE(IUOUTTS,2010) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP, ! global time-series
     1             IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               ELSE IF(IDMODEL.GT.1) THEN ! child model        
                  WRITE(IUOUTTS,2010) MPSTP,NP,J,I,K,CXOFF,CYOFF,Z, ! global time-series
     1             ZL,T,NSTEP,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               END IF
            END IF
         END IF    
2000  FORMAT(I7,1X,I7,3(1X,I4),1X,1PE12.5,4(1X,E12.5),2(1X,I7),2X,A)
2010  FORMAT(I7,1X,I7,3(1X,I4),1X,1PE12.5,4(1X,E12.5),4(1X,I7),2X,A)
      END IF
 
      RETURN
      END
 
C***** SUBROUTINE *****
cjed  ADD PARTICLE INDEX NUMBER NPARTVAL
cjed  ADD UNIT NUMBER IUOUT FOR ADDITIONAL ASCII OUTPUT FOR EACH TIME STEP
cjed      SUBROUTINE WRITPL(IU,ICMPCT,IP,X,Y,ZL,Z,T,J,I,K,NSTEP,NROW,NCOL)
      SUBROUTINE WRITPL(IU,IUOUTPL,ISLGR,IDMODEL_START,IDMODEL,ICMPCT,
     1 IP,X,Y,ZL,Z,T,J,I,K,NSTEP,NROW,NCOL,NPARTVAL,XOFF,YOFF,ZOFF,
     2 PARTASSOC)
c
      CHARACTER*40 PARTASSOC
      IF(ISLGR.EQ.1) THEN
          CXOFF=X+XOFF
          CYOFF=Y+YOFF
      END IF
      IF(ICMPCT.EQ.1) THEN ! compact format
         ND= (K-1)*NROW*NCOL + (I-1)*NCOL + J
cjed     ADD PARTICLE INDEX NUMBER NPARTVAL
cjed     WRITE(IU,1000) IP,X,Y,ZL,Z,T,ND,NSTEP
cjed1000 FORMAT(I7,1X,1PE12.5,4(1X,E12.5),2(1X,I7))
         WRITE(IU,1000) IP,X,Y,ZL,Z,T,ND,NSTEP,NPARTVAL,PARTASSOC ! pathline file for single model   
            IF(IUOUTPL.GT.0) THEN ! global pathline file specified?
               IF(ISLGR.EQ.1) THEN ! more than one model?
                  IF(IDMODEL.EQ.1) THEN ! parent model
                     WRITE(IUOUTPL,2010) IP,X,Y,ZL,Z,T,J,I,K,NSTEP, ! global pathline file
     1                IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
     
                  ELSE IF(IDMODEL.GT.1) THEN ! child model
                     WRITE(IUOUTPL,2010) IP,CXOFF,CYOFF,ZL,Z,T,J,I,K,  ! global pathline file
     1                NSTEP,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
                  END IF
               END IF
            END IF
1000  FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I7),1X,A)
      
      ELSE IF(ICMPCT.EQ.2) THEN ! binary format
          ND= (K-1)*NROW*NCOL + (I-1)*NCOL + J
cjed      ADD PARTICLE INDEX NUMBER NPARTVAL
cjed      WRITE(IU) IP,X,Y,ZL,Z,T,ND,NSTEP
          WRITE(IU) IP,X,Y,ZL,Z,T,ND,NSTEP,NPARTVAL,PARTASSOC ! pathline file for single model
          IF(ISLGR.EQ.1) THEN ! more than one model?
             IF(IUOUTPL.GT.0) THEN ! global pathline file specified?
                IF(IDMODEL.EQ.1) THEN ! parent model
                   WRITE(IUOUTPL) IP,X,Y,ZL,Z,T,J,I,K,NSTEP, ! global pathline file
     1              IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
                ELSE IF(IDMODEL.GT.1) THEN ! child model
                   WRITE(IUOUTPL) IP,CXOFF,CYOFF,ZL,Z,T,J,I,K,NSTEP, ! global pathline file
     1              IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
                END IF           
             END IF
          END IF
      ELSE ! standard format
cjed  ADD PARTICLE INDEX NUMBER NPARTVAL
cjed        WRITE(IU,2000) IP,X,Y,ZL,Z,T,J,I,K,NSTEP
cjed2000    FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I4),1X,I7)
         WRITE(IU,2000) IP,X,Y,ZL,Z,T,J,I,K,NSTEP,NPARTVAL,PARTASSOC ! pathline file for single model
         IF(ISLGR.EQ.1) THEN ! more than one model?
            IF(IUOUTPL.GT.0) THEN !global pathline file specified?
               IF(IDMODEL.EQ.1) THEN ! parent model
                  WRITE(IUOUTPL,2010) NPARTVAL,X,Y,ZL,Z,T,J,I,K,NSTEP, ! global pathline file
     1             IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               ELSE IF(IDMODEL.GT.1) THEN ! child model
                  WRITE(IUOUTPL,2010) NPARTVAL,CXOFF,CYOFF,ZL,Z,T,J,I,K, ! global pathline file
     1             NSTEP,IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
               END IF
            END IF
         END IF
2000  FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I4),1X,I7,1X,I7,2X,A) ! single model format
2010  FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I4),1X,I7,3(1X,I7),2X,A) ! global pathline format
cjed  END ADDITIONS
      END IF
      RETURN
      END
      
C***********************************************************************
      SUBROUTINE WRITSCRATCH(IN,IOUT)
      IMPLICIT NONE
      INTEGER IN,IOUT
      CHARACTER*220 LINE
      
      DO      
          READ(IN,'(A)',END=100) LINE
          WRITE(IOUT,'(A)') LINE
      ENDDO
      
  100 RETURN
      END SUBROUTINE
C***********************************************************************
      SUBROUTINE WRITEUNFSTART(IN,IOUT,IDMODEL_START)
      IMPLICIT NONE
      INTEGER IN,IOUT
      INTEGER J,I,K,JCODE,ICODE,KCODE,IDPART,IDMODEL_START
      REAL X,Y,Z,TOT
      CHARACTER*40 PARTASSOC

      DO    
           READ(IOUT,END=50)
      END DO
   50 CONTINUE  
     
      DO
           READ(IN,*,END=100) J,I,K,X,Y,Z,JCODE,ICODE,KCODE,TOT,
     1     IDPART,PARTASSOC
      
           WRITE(IOUT) J,I,K,X,Y,Z,JCODE,ICODE,KCODE,TOT,
     1     IDPART,PARTASSOC,IDMODEL_START
      END DO
  100 RETURN  
      END SUBROUTINE      

C***********************************************************************

      SUBROUTINE WRITEFSTART(IN,IOUT)
      IMPLICIT NONE
      INTEGER IN,IOUT
      INTEGER J,I,K,JCODE,ICODE,KCODE,IDPART
      REAL X,Y,Z,TOT
      CHARACTER*40 PARTASSOC

      DO
           READ(IN,END=200) J,I,K,X,Y,Z,JCODE,ICODE,KCODE,TOT,
     1     IDPART,PARTASSOC
           WRITE(IOUT,100) J,I,K,X,Y,Z,JCODE,ICODE,KCODE,TOT,
     1     IDPART,PARTASSOC
      END DO
  100 FORMAT(3I5,2X,3F12.7,2X,3(I1,1X),1X,E13.5,2X,I5,1X,A) 
  200 RETURN
      END SUBROUTINE      

C***********************************************************************

      SUBROUTINE WRITEUNFEP(IN,IOUT)
      IMPLICIT NONE
      INTEGER IN,IOUT
      INTEGER IZONE,J,I,K,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE
      INTEGER IDMODEL_START,IDMODEL,IDPART
      REAL X,Y,ZGLOB,Z,TOT,XSTRT,YSTRT,ZLSTRT,TRLS,ZSTRT
      CHARACTER PARTASSOC
      
      DO
          READ(IN,END=100) IZONE,J,I,K,X,Y,ZGLOB,Z,TOT,XSTRT,YSTRT,
     1     ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLS,ZSTRT,
     2     IDMODEL_START,IDMODEL,IDPART,PARTASSOC
          
          WRITE(IOUT) IZONE,J,I,K,X,Y,ZGLOB,Z,TOT,XSTRT,YSTRT,
     1     ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLS,ZSTRT,
     2     IDMODEL_START,IDMODEL,IDPART,PARTASSOC          
          
      END DO
      
  100 RETURN
      END SUBROUTINE
C***********************************************************************

      SUBROUTINE WRITEUNFTS(IN,IOUT)
      IMPLICIT NONE
      INTEGER IN,IOUT
      INTEGER MPSTP,NP,J,I,K,NSTEP,IDMODEL_START
      INTEGER IDMODEL,NPARTVAL
      REAL X,Y,Z,ZL,T
      CHARACTER*40 PARTASSOC
      
      DO
          READ(IN,END=100) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP,
     1     IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
          
          WRITE(IOUT) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP,
     1     IDMODEL_START,IDMODEL,NPARTVAL,PARTASSOC
          
      END DO
      
  100 RETURN
      END SUBROUTINE
C***********************************************************************